unit fReceive;

interface

uses
  Forms, fDefine, NMUDP, Dialogs, StdCtrls, ExtCtrls, Controls, Classes;

type
  TfrmReceive = class(TForm)
    Button1: TButton;
    GroupBox2: TGroupBox;
    Panel1: TPanel;
    Label0: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    ListBox0: TListBox;
    ListBox1: TListBox;
    ListBox2: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    function GetLabels(Index: Integer): TLabel;
    function GetListBoxes(Index: Integer): TListBox;
  protected
    InUDP: TNMUDP;
    FActive: Boolean;
    procedure DO_DataReceived(Sender: TComponent;
      NumberBytes: Integer; FromIP: String; Port: Integer);
  public
    procedure Start();
    procedure Stop();
    procedure Decode(S: string);
    property Labels[Index: Integer]: TLabel read GetLabels;
    property ListBoxes[Index: Integer]: TListBox read GetListBoxes;
  end;

var
  frmReceive: TfrmReceive;

implementation

uses SysUtils;

{$R *.dfm}

procedure TfrmReceive.Start;
begin
  FActive := True;
  Button1.Caption := 'Stop';
  if InUDP = nil then
  begin
    InUDP := TNMUDP.Create(Self);
    InUDP.LocalPort := 12345;
    InUDP.OnDataReceived := Self.DO_DataReceived;
  end;
end;

procedure TfrmReceive.Stop;
begin
  FActive := False;
  Button1.Caption := 'Start';
  if InUDP <> nil then
  begin
    InUDP.OnDataReceived := nil;
    InUDP.LocalPort := 0;
    FreeAndNil(InUDP);
  end;
end;

procedure TfrmReceive.Button1Click(Sender: TObject);
begin
  FActive := not FActive;
  case FActive of
    True: Start();
    else  Stop();
  end;
end;

procedure TfrmReceive.Decode(S: string);
var
  Index: Integer;
  lbl: TLabel;
  lbx: TListBox;
begin
  Index := Ord(S[5]);
  lbl := Labels[Index];
  lbx := ListBoxes[Index];
  if Assigned(lbl) then
  begin
    lbl.Caption := PacketToStr(PPacket(@S[1]));
    if Assigned(lbx) then
    begin
      lbx.Items.Add(lbl.Caption);
      if lbx.Count > 13 then
        lbx.Items.Delete(0);
    end;
  end;
end;

procedure TfrmReceive.DO_DataReceived(Sender: TComponent;
  NumberBytes: Integer; FromIP: String; Port: Integer);
var
  Buff: array[0..1023] of Char;
begin
  InUDP.ReadBuffer(Buff, NumberBytes);
  _decode_(Buff, NumberBytes, Decode);

end;

function TfrmReceive.GetLabels(Index: Integer): TLabel;
begin
  Result := FindComponent('Label' + IntToStr(Index)) as TLabel;
end;

function TfrmReceive.GetListBoxes(Index: Integer): TListBox;
begin
  Result := FindComponent('ListBox' + IntToStr(Index)) as TListBox;
end;

procedure TfrmReceive.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := not FActive;
  if not CanClose then
    ShowMessage('Stop First !!!');
end;

end.
