unit fTransmit;

interface

uses
  Forms, Controls, StdCtrls, Classes, ExtCtrls, Dialogs, fDefine, ScktComp,
  IdBaseComponent, IdComponent, IdUDPBase, IdUDPServer, IdUDPClient;

type
  TfrmTrans = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    LabelX: TLabel;
    Timer1: TTimer;
    Panel1: TPanel;
    Label0: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    ListBox0: TListBox;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  protected
    OutUDP: TIdUdpClient;
    OutTCP: TServerSocket;
    function GetLabels(Index: Integer): TLabel;
    function GetListBoxes(Index: Integer): TListBox;
  public
    procedure Start();
    procedure Stop();
    procedure Decode(S: string);
    property Labels[Index: Integer]: TLabel read GetLabels;
    property ListBoxes[Index: Integer]: TListBox read GetListBoxes;
  end;

var
  frmTrans: TfrmTrans;

implementation

uses SysUtils;

{$R *.dfm}

{ TForm1 }

procedure TfrmTrans.FormCreate(Sender: TObject);
begin
  Randomize;
end;

function TfrmTrans.GetLabels(Index: Integer): TLabel;
begin
  Result := FindComponent('Label' + IntToStr(Index)) as TLabel;
end;

function TfrmTrans.GetListBoxes(Index: Integer): TListBox;
begin
  Result := FindComponent('ListBox' + IntToStr(Index)) as TListBox;
end;

procedure TfrmTrans.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := not Timer1.Enabled;
  if not CanClose then
    ShowMessage('Stop First !!!');
end;

procedure TfrmTrans.Button1Click(Sender: TObject);
begin
  Timer1.Enabled := not Timer1.Enabled;
  case Timer1.Enabled of
    True: Start();
    else  Stop();
  end;
end;

procedure TfrmTrans.Start;
begin
  Timer1.Enabled := True;
  Button1.Caption := 'Stop';
  if OutUDP = nil then
  begin
    OutUDP := TIdUdpClient.Create(Self);
    OutUDP.Host := '127.0.0.1';
    OutUDP.Port := 12345;
    OutUDP.Active := True;
  end;
  if OutTCP = nil then
  begin
    OutTCP := TServerSocket.Create(Self);
    OutTCP.Port := 54321;
    OutTCP.Active := True;
  end;
end;

procedure TfrmTrans.Stop;
begin
  Timer1.Enabled := False;
  Button1.Caption := 'Start';
  if OutTCP <> nil then
  begin
    OutTCP.Active := False;
    OutTCP.Port := 0;
    FreeAndNil(OutTCP);
  end;

  if OutUDP<> nil then
  begin
    OutUDP.Active := False;
    OutUDP.Port := 0;
    FreeAndNil(OutUDP);
  end;
end;

procedure TfrmTrans.Timer1Timer(Sender: TObject);
var
  p: TPacket;
  I: Integer;
  sock: TServerWinSocket;
begin
  FillChar(p, SizeOf(p), 0);
  p.r.STX := $30;
  p.r.PktID := Random(3);
  case p.r.PktID of
    0:begin
        p.r.Len  := SizeOf(TPkt0) + 5;//STX, Len, ID
        p.r.p0.ID:= 1000+Random(10);
        p.r.p0.B := Random(1000);
        p.r.p0.W := Random(1000);
        p.r.p0.I := Random(100);
        p.r.p0.S := Random(100) + Random(100) / 100;
        p.r.p0.D := Random(100) + Random(100) / 100;
      end;
    1:begin
        p.r.Len  := SizeOf(TPkt1) + 5;//STX, Len, ID
        p.r.p0.ID:= 1000+Random(10);
        p.r.p1.I := Random(1000);
        p.r.p1.S := Random(100) + Random(100) / 100;
        p.r.p1.D := Random(100) + Random(100) / 100;
      end;
    2:begin
        p.r.Len := SizeOf(TPkt2) + 5;     //STX, Len, ID
        p.r.p2.Count := Random(5) + 1;   //1~5
        p.r.Len := p.r.Len - (5-p.r.p2.Count) * SizeOf(Single);
        p.r.p0.ID := 1000+Random(10);

        for I := 0 to p.r.p2.Count-1 do
          p.r.p2.Data[I] := Random(100) + Random(100) / 100;
          
      end;
  end;

  p.r.CRC := CalcCRC(@p, p.r.Len);  //pCRC
  
  LabelX.Caption := PacketToStr(@P);//Display Packet String


//Actions:
  
  {0} _decode_(PChar(@p), p.r.Len, Decode);
  //Decode(PChar(@p), p.r.Len);

  {1} //NPacketeUDP, Port = 12345.
      if Assigned(OutUDP) then
        OutUDP.SendBuffer(p.Buff, p.r.Len);

  {2} //NPacketeTCP, Port = 54321.
      if Assigned(OutTCP) then
      begin
        sock := OutTCP.Socket;
          for I := sock.ActiveConnections-1 downto 0 do
            if Assigned(sock.Connections[I]) then
              sock.Connections[I].SendBuf(p.Buff, p.r.Len);
      end;
      
end;

procedure TfrmTrans.Decode(S: string);
var
  Index: Integer;
  lbl: TLabel;
  lbx: TListBox;
begin
  Index := Ord(S[5]);
  lbl := Labels[Index];
  lbx := ListBoxes[Index];
  if Assigned(lbl) then
  begin
    lbl.Caption := PacketToStr(PPacket(@S[1]));
    if Assigned(lbx) then
    begin
      lbx.Items.Add(lbl.Caption);
      if lbx.Count > 13 then
        lbx.Items.Delete(0);
    end;
  end;
end;

end.

